package com.rbevans;

import java.io.IOException;

import com.fasterxml.jackson.core.JsonParseException;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.fasterxml.jackson.databind.ObjectMapper;

public class Main {

	public static void main(String[] args) {

		Person bob = new Person();
		bob.setFirstName("Bob");
		bob.setLastName("Evans");
		bob.setAge(40);

		System.out.println("Created new person -> " + bob);
		
		ObjectMapper mapper = new ObjectMapper();
		String jsonString = null;

		try {
			jsonString = mapper.writeValueAsString(bob);
			System.out.println("Mapper created JSON string -> " + jsonString);
		} catch (JsonProcessingException e) {
			System.out.println("Unable to convert person to JSON string");
			e.getMessage();
			e.printStackTrace();
			System.exit(1);

		}
		
		String inputJson = "{\"firstName\":\"Rich\",\"lastName\":\"Spiegel\",\"age\":35}";
		System.out.println("\nPreparing to convert JSON object of " + inputJson);
		
		Person rich = new Person();
		try {
			rich = mapper.readValue(inputJson,  Person.class);
		} catch (JsonMappingException jme) {
			System.out.println("Could not map JSON string to object because " + jme.getMessage());
			jme.printStackTrace();
			System.exit(1);
		} catch (JsonParseException jpe) {
			System.out.println("Could not parse JSON string because " + jpe.getMessage());
			jpe.printStackTrace();
			System.exit(1);
		} catch (IOException e) {
			System.out.println("General IO error of " + e.getMessage());
			e.printStackTrace();
			System.exit(1);
		}
		System.out.println("Mapper turned JSON string into " + rich);
				
	}
}
